## Outer space
Описания пока нет :(

Участникам выдать `algorithm.py` и `hash.txt`

## Writeup
36 символов – размер алфавита флага (английский алфавит + цифры, { и } заменяются на v и w). Функции `encrypt` и `decrypt` – кодирование и декодирование в 36-ричную систему с тем же алфавитом.

Алгоритм выбирает случайную начальную позицию, и до “истощения” флага вставляет на текущую позицию соответствующую букву флага и случайный символ из алфавита. Затем меняет позицию, раскодируя текущее значение блока в число и переходя на нее. После записи флага подобным образом алгоритм заполняет оставшиеся позиции случайными значениями.

Для решения достаточно перебрать исходную позицию, пройти весь путь (проделывая те же операции, что и алгоритм шифрования), по ходу записывая первые буквы получаемых значений блоков, и проверить, начинается ли получившаяся последовательность на “mctf“.

Осуществить это можно, например, с помощью следующего скрипта:

```python
from algorithm import decrypt


def split_data(data, n):
    return [data[i:i + n] for i in range(0, len(data), n)]


with open('hash.txt') as file:
    data = file.read()

data = split_data(data, 2)

for chunk in data:
    if chunk[0] == 'm':
        flag = chunk[0]
        pos = decrypt(chunk)

        while pos < len(data):
            if not 'mctf'.startswith(flag[:4]):
                break

            if data[pos][0] == 'w':
                print(flag.replace('v', '{') + '}')
                break

            flag += data[pos][0]
            pos = decrypt(data[pos])
```

## Flag
mctf{br0k3nha5h}

## Complexity
Medium

